# rubygemsmirror

#### Table of Contents

1. [Description](#description)
1. [Setup - The basics of getting started with rubygemsmirror](#setup)
    * [What rubygemsmirror affects](#what-rubygemsmirror-affects)
    * [Setup requirements](#setup-requirements)
    * [Beginning with rubygemsmirror](#beginning-with-rubygemsmirror)
1. [Usage - Configuration options and additional functionality](#usage)
1. [Reference - An under-the-hood peek at what the module is doing and how](#reference)
1. [Limitations - OS compatibility, etc.](#limitations)
1. [Development - Guide for contributing to the module](#development)

## Description

This module will make it possible to mirror rubygems using the rubygems-mirror gem

## Setup

### What rubygemsmirror affects

This module will:-
* install the rubygems-mirrir gem
* create the gem user
* set up the home directory at /var/lib/gem
* write the configuration to /var/lib/gem/.gem/.mirrorrc
* configure the cron to sync rubygems

### Setup Requirements

This module requires ruby to be installed.
This module requires the parent directory to be created. 

### Beginning with rubygemsmirror

Include the ::rubygemsmirror class.

```puppet
class { 'rubygemsmirror':
  destination => '/var/www/gems'
}
```

By default manage destination will be set to true and gems will be created. /var/www must already exist.


### Beginning with rubygemsmirror
```puppet
class { 'rubygemsmirror':
  destination,        # Required - Where to put the gems
  Boolean $managecron # Optional - manages cron? (true)
  Array   $cronhours  # Optional - when to sync hours ([06, 18])
  managedestination,  # Optional - Attempt to create destination (true)
  user,               # Optional - Who owns files and runs crons (gem)
  userhome,           # Optional - users home dir (/var/lib/gem)
  delete,             # Optional - Delete removed gems (false)
  threads,            # Optional - Download threads (10)
  retries,            # Optional - How many times to retry (3)
  from,               # Optional - Where to mirror gems from (https://rubygems.org) 
  skiperrors          # Optional - Skip errors (true)
}
```