class rubygemsmirror (
  String  $destination,
  Boolean $managecron        = $::rubygemsmirror::params::managecron,
  Array   $cronhours         = $::rubygemsmirror::params::cronhours,
  Boolean $managedestination = $::rubygemsmirror::params::managedestination,
  String  $user              = $::rubygemsmirror::params::user,
  String  $userhome          = $::rubygemsmirror::params::userhome,
  Boolean $delete            = $::rubygemsmirror::params::delete,
  Integer $threads           = $::rubygemsmirror::params::threads,
  Integer $retries           = $::rubygemsmirror::params::retries,
  String  $from              = $::rubygemsmirror::params::from,
  Boolean $skiperrors        = $::rubygemsmirror::params::skiperrors,
  Boolean $manageruby        = $::rubygemsmirror::params::manageruby
) inherits rubygemsmirror::params {

  if $managedestination {
    file {$destination:
      ensure => directory,
      owner  => $user,
      group  => $user,
      mode   => '0755'
    }
  }

  if $managecron {
    cron { 'gemdownload':
      command => '/usr/bin/ruby /usr/local/bin/mirror.rb',
      user    => $user,
      hour    => $cronhours,
      minute  => 0
    }
  }

  file {$userhome:
    ensure => directory,
    owner  => $user,
    group  => $user,
    mode   => '0755',
  }

  file {"${userhome}/.gem/":
    ensure => directory,
    owner  => $user,
    group  => $user,
    mode   => '0755',
  }

  user {$user:
    ensure => present,
    home   => '/var/lib/gem',
    shell  => '/bin/bash'
  }

  file {'/usr/local/bin/mirror.rb':
    ensure  => file,
    owner   => 'root',
    group   => 'root',
    mode    => '0644',
    content => file('rubygemsmirror/mirror.rb')
  }

  if $manageruby {
    package{'ruby':
      ensure => installed
    }
  }
  package {'rubygems-mirror':
    ensure   => installed,
    provider => gem,
    require  => Package['ruby']
  }

  file {"${userhome}/.gem/.mirrorrc":
    ensure  => file,
    owner   => $user,
    group   => $user,
    mode    => '0644',
    content => epp('rubygemsmirror/rubygems-mirror.yaml')
  }
}
